import { createTokenWriter } from '../utils/token-writer';

export const createTokenBundle = (name = 'token') => {
  const { readToken, writeToken } = createTokenWriter(name);
  return {
    name: 'token',
    getReducer: () => {
      const initial = {
        token: readToken()
      };
      return (state = initial, { type, payload }) => {
        if (type === 'TOKEN_UPDATED') {
          return Object.assign({}, state, { token: payload });
        }
        return state;
      };
    },
    selectAuthToken: state => state.token.token,
    selectIsSignedIn: state => !!state.token.token,
    doReceiveToken: token => ({ dispatch }) => {
      writeToken(token);
      dispatch({ type: 'TOKEN_UPDATED', payload: token });
    }
  };
};